<template>
  <div class="companyList">
    <template v-if="isShowAdd">
      <div class="head-title">
        活动类型管理
        <el-button style="float:right;margin-top: -5px;" size="small" type="primary"
          @click="isShowAdd=false,clearMsg()">新增</el-button>
      </div>
      <div class="content">
        <div>
          <div class="searchInput" style="width:250px">
            <el-input @keyup.enter.native="msg.pageIndex=1,getList()" @clear="msg.pageIndex=1,getList()"
              style="display:inline-block;width:225px;height:30px" placeholder="活动类型名称" v-model="msg.TypeName"
              size="small" clearable>
            </el-input>
            <span @click="msg.pageIndex=1,getList()" class="el-icon-search"
              style="color:#979dad;font-size:14px;position:relative;top:1px"></span>
          </div>
        </div>
        <el-table :data="tableData" v-loading="loading" border style="width: 100%;margin:20px 0">
          <el-table-column prop="Id" label="编号" width="100">
          </el-table-column>
          <el-table-column prop="TypeName" label="类型名称">
          </el-table-column>
          <el-table-column prop="CoverImage" label="封面图">
            <template slot-scope="scope">
              <div class="app-image"
                :style="{backgroundImage:'url(' + scope.row.CoverImage + ')',backgroundSize:'cover'}">
              </div>
            </template>
          </el-table-column>
          <el-table-column prop="LableNameList" label="标签">
            <template slot-scope="scope">
                <span v-for="(LItem,Lindex) in scope.row.LableNameList" style="margin-right:5px;" :key="Lindex">{{LItem}}</span>
            </template>
          </el-table-column>
          <el-table-column prop="Id" width="200" label="操作">
            <template slot-scope="scope">
              <el-tooltip class="item" effect="dark" content="编辑" placement="top">
                <img @click="EditType(scope.row)" style="width:32px;height:32px" src="../../assets/img/userman/edit.png"
                  alt="">
              </el-tooltip>
              <el-tooltip class="item" effect="dark" content="删除" placement="top-start">
                <img @click="delType(scope.row)" style="width:32px;height:32px;margin:0 10px"
                  src="../../assets/img/userman/del.png" alt="">
              </el-tooltip>
            </template>
          </el-table-column>
        </el-table>
        <el-pagination style="text-align:right" background @current-change="handleCurrentChange"
          :page-size="msg.pageSize" :current-page.sync="msg.pageIndex" layout="total,prev, pager, next" :total="total">
        </el-pagination>
      </div>
    </template>
    <template v-else>
      <div class="head-title">
        <span @click="isShowAdd=true" style="color:rgb(64, 158, 255);cursor:pointer;">活动类型管理</span><span
          style="margin:0 9px;color:#C0C4CC">/</span><span>修改活动类型</span>
      </div>
      <div class="content">
        <el-form label-width="120px" :model="addMsg" :rules="rules" ref="addMsg">
          <el-form-item label="类型名称" prop="TypeName" class="is-required">
            <el-input type="text" class="w400" v-model="addMsg.TypeName" size="small" maxlength="20"></el-input>
          </el-form-item>
          <el-form-item label="封面图" size="small">
            <el-button @click="isShowImage=true" size="small">选择文件</el-button>
            <div class="app-gallery-item" style="position: relative;width: 100px;margin-top: 10px;border:none;">
              <img v-if="!addMsg.CoverImage || addMsg.CoverImage==''" src="../../assets/img/default.png"
                style="width:80px;height:80px" alt="">
              <img v-else style="width:80px;height:80px" :src="addMsg.CoverImage" alt="">
            </div>
          </el-form-item>
          <el-form-item label="标签" size="small">
            <el-tag :key="tag" v-for="tag in dynamicTags" closable :disable-transitions="false"
              @close="handleClose(tag)">
              {{tag}}
            </el-tag>
            <el-input class="input-new-tag" v-if="inputVisible" v-model="inputValue" ref="saveTagInput" size="small"
              @keyup.enter.native="handleInputConfirm" @blur="handleInputConfirm">
            </el-input>
            <el-button v-else class="button-new-tag" size="small" @click="showInput">+ 标签</el-button>
          </el-form-item>
        </el-form>
      </div>
      <el-button size="small" style="margin-top:20px;padding:9px 25px;" type="primary" @click="submitform('addMsg')">保存
      </el-button>
    </template>
    <!-- 选择文件 -->
    <el-dialog title="选择文件" :visible.sync="isShowImage" width="1240px">
      <ChooseImg @SelectId="SelectId"></ChooseImg>
    </el-dialog>
  </div>
</template>
<script>
  import ChooseImg from "@/components/global/ChooseImg.vue";
  export default {
    components: {
      ChooseImg,
    },
    data() {
      return {
        rules: {
          TypeName: [{
            required: true,
            message: '请输入类型名称',
            trigger: 'blur'
          }],
        },
        msg: {
          pageIndex: 1,
          pageSize: 10,
          TypeName: '',
        },
        total: 0,
        isShowAdd: true, //是否显示新增
        tableData: [], //数据列表
        isShowImage: false, //是否显示选择图片弹窗
        addMsg: {
          Id: 0, //编号
          TypeName: "", //类型名称
          CoverImage: "", //封面图
          LableNameList: []
        },
        dynamicTags:[], //标签数组
        inputVisible: false,
        inputValue:'',
      };
    },
    created() {
      this.getList();
    },
    methods: {
      clearMsg() {
        this.addMsg.Id = 0;
        this.addMsg.TypeName = "";
        this.addMsg.CoverImage = "";
      },
      SelectId(msg) {
        let url = this.getIconLink(msg.url)
        this.addMsg.CoverImage = url
        this.isShowImage = false;
      },
      getList() {
        this.loading = true;
        this.apipost("/api/Trade/GetCommerceActivityTypePage", this.msg, res => {
          this.loading = false;
          if (res.data.resultCode == 1) {
            this.total = res.data.data.count;
            let pageData = res.data.data.pageData;
            this.tableData = pageData;
          }
        })
      },
      handleCurrentChange(val) {
        this.msg.pageIndex = val;
        this.getList();
      },
      //修改类型
      EditType(item) {
        this.apipost("/api/Trade/GetCommerceActivityType", {
          Id: item.Id
        }, res => {
          if (res.data.resultCode == 1) {
            this.isShowAdd = false;
            var tempData = res.data.data;
            this.addMsg.Id = tempData.Id;
            this.addMsg.TypeName = tempData.TypeName;
            this.addMsg.CoverImage = tempData.CoverImage;
            this.dynamicTags = tempData.LableNameList;
            console.log(res,'res');
          } else {
            this.Error(res.data.message);
          }
        })
      },
      //删除类型
      delType(item) {
        let that = this;
        that.Confirm("是否删除?", function () {
          that.apipost(
            "/api/Trade/RemoveCommerceActivityType", {
              Id: item.Id,
              Status: 1
            },
            res => {
              if (res.data.resultCode == 1) {
                that.Success(res.data.message);
                that.getList();
              } else {
                that.Error(res.data.message);
              }
            },
          );
        });
      },
      //新增活动类型
      submitform(formName) {
        this.$refs[formName].validate((valid) => {
          if (valid) {
            console.log(this.dynamicTags,'dynamicTags');
            this.addMsg.LableNameList = this.dynamicTags;
            this.apipost("/api/Trade/SetCommerceActivityType", this.addMsg, res => {
              if (res.data.resultCode == 1) {
                this.isShowAdd = true;
                this.getList();
                this.clearMsg();
                this.Success(res.data.message);
              } else {
                this.Error(res.data.message);
              }
            })
          } else {
            return false;
          }
        });
      },
      handleInputConfirm() {
        let inputValue = this.inputValue;
        if (inputValue) {
          this.dynamicTags.push(inputValue);
        }
        this.inputVisible = false;
        this.inputValue = '';
      },
      showInput() {
        this.inputVisible = true;
        this.$nextTick(_ => {
          this.$refs.saveTagInput.$refs.input.focus();
        });
      },
      //删除
      handleClose(tag) {
        this.dynamicTags.splice(this.dynamicTags.indexOf(tag), 1);
      }
    },
    mounted() {}
  };

</script>
<style>
  .companyList .remark_name {
    color: #888888;
    font-size: 12px;
    margin-left: 10px;
    float: right;
  }

  .companyList .app-image {
    background-position: center center;
    width: 50px;
    height: 50px;
    border-radius: 0%;
    float: left;
    margin-right: 8px;
  }

  .companyList .blue {
    color: #409EFF;

  }

  .companyList .content .searchInput {
    border: 1px solid #DCDFE6;
    border-radius: 4px;
  }

  .companyList .content .searchInput .el-input__inner {
    border: none;
    outline: none;
    height: 30px;
    line-height: 30px;
  }

  .companyList .content .searchInput {
    line-height: normal;
    display: inline-table;
    width: 100%;
    border-collapse: separate;
    border-spacing: 0;
    width: 250px;
    margin-right: 20px;
  }

  .companyList .content {
    background: #fff;
    margin-top: 10px;
    padding: 20px;
    box-sizing: border-box;
  }
  .companyList .input-new-tag {
    width: 90px;
    margin-left: 10px;
    vertical-align: bottom;
    margin-right:5px;
  }
  .companyList .el-tag {
    margin-right:5px;
  }
  
</style>
